package nc.ui.gl.querymodel;

import com.borland.dx.dataset.Column;
import com.borland.dx.dataset.DataRow;
import com.borland.dx.dataset.StorageDataSet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GradientPaint;
import java.awt.Insets;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Hashtable;
import java.util.Vector;
import javax.swing.JFrame;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.TableColumn;
import nc.bs.logging.Logger;
import nc.ui.gl.accbook.CopyTwoTableUtil;
import nc.ui.gl.querymodel.DBReportTableModel;
import nc.ui.gl.querymodel.QueryBrowseCellRenderer;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UIScrollPane;
import nc.ui.pub.beans.UITable;
import nc.ui.pub.beans.UITablePane;
import nc.vo.pub.querymodel.QueryConst;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.DialShape;
import org.jfree.chart.plot.MeterPlot;
import org.jfree.data.DefaultValueDataset;
import org.jfree.data.Range;

public class QueryBrowsePanel extends UIPanel implements ListSelectionListener {

   private StorageDataSet m_dataset = null;
   private StorageDataSet m_dsBeforeRotate = null;
   private boolean m_bMeterShown = false;
   private UITablePane ivjTablePnCenter = null;
   private UIScrollPane ivjPnSouth = null;
   private String m_currTypePK = null;
   private String m_pkCorp = null;
   private int m_fixColumnSize;
   private String m_bookstyle;


   public QueryBrowsePanel() {
      this.initialize();
   }

   public QueryBrowsePanel(boolean p0) {
      super(p0);
   }

   public StorageDataSet getDataset() {
      return this.m_dataset;
   }

   public void getDecimalCol(Vector vecColname, Vector vecCaption) {
   }

   public StorageDataSet getDsBeforeRotate() {
      return this.m_dsBeforeRotate;
   }

   public Hashtable getPeneRow() {
      Hashtable hashPeneRow = null;
      int iSelRow = this.getSelRow();
      if(iSelRow != -1) {
         hashPeneRow = new Hashtable();
         int iColCount = this.getTable().getColumnCount();

         for(int i = 0; i < iColCount; ++i) {
            Object obj = this.getTable().getValueAt(iSelRow, i);
            String value = obj == null?" ":obj.toString();
            String colName = this.getDataset().getColumn(i).getColumnName();
            hashPeneRow.put(colName, value);
         }
      }

      return hashPeneRow;
   }

   private UIScrollPane getPnSouth() {
      if(this.ivjPnSouth == null) {
         try {
            this.ivjPnSouth = new UIScrollPane();
            this.ivjPnSouth.setName("PnSouth");
            this.ivjPnSouth.setPreferredSize(new Dimension(10, 2));
            this.ivjPnSouth.setBackground(Color.blue);
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjPnSouth;
   }

   public int getSelCol() {
      return this.getTable().getColumnCount() == 0?-1:this.getTable().getSelectedColumn();
   }

   public int getSelRow() {
      return this.getTable().getRowCount() == 0?-1:this.getTable().getSelectedRow();
   }

   public UITable getTable() {
      return this.getTablePnCenter().getTable();
   }

   private UITablePane getTablePnCenter() {
      if(this.ivjTablePnCenter == null) {
         try {
            this.ivjTablePnCenter = new UITablePane();
            this.ivjTablePnCenter.setName("TablePnCenter");
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjTablePnCenter;
   }

   public UITablePane getTablePnPub() {
      return this.getTablePnCenter();
   }

   private void handleException(Throwable exception) {
      Logger.debug("--------- 未捕捉到的异常 ---------");
      exception.printStackTrace(System.out);
   }

   private void initialize() {
      try {
         this.setName("QueryBrowsePanel");
         this.setLayout(new BorderLayout());
         this.setSize(640, 480);
         this.add(this.getTablePnCenter(), "Center");
         this.add(this.getPnSouth(), "South");
      } catch (Throwable var2) {
         this.handleException(var2);
      }

      this.getTable().setAutoResizeMode(0);
      CopyTwoTableUtil.getInstance().replaceCopy(this.getTable(), (UITable)null);
      this.getTable().getTableHeader().setBackground(QueryConst.HEADER_BACK_COLOR);
      this.getTable().getTableHeader().setForeground(QueryConst.HEADER_FORE_COLOR);
   }

   public void initListener(boolean bAdd) {
      this.getTable().getSelectionModel().removeListSelectionListener(this);
      if(bAdd) {
         this.getTable().getSelectionModel().addListSelectionListener(this);
         this.getPnSouth().setPreferredSize(new Dimension(10, 168));
      } else {
         this.getPnSouth().setPreferredSize(new Dimension(10, 2));
         this.m_bMeterShown = false;
      }

      this.validate();
   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         QueryBrowsePanel aQueryBrowsePanel = new QueryBrowsePanel();
         exception.setContentPane(aQueryBrowsePanel);
         exception.setSize(aQueryBrowsePanel.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         System.err.println("nc.ui.pub.beans.UIPanel 的 main() 中发生异常");
         var4.printStackTrace(System.out);
      }

   }

   private JFreeChart makeMeterchart(double dValue, double dMin, double dMax, String title, int iDialType) {
      DefaultValueDataset data = new DefaultValueDataset(dValue);
      MeterPlot plot = new MeterPlot(data);
      plot.setRange(new Range(dMin, dMax));
      plot.setUnits("");
      double dDif = (dMax - dMin) / 4.0D;
      plot.setCriticalRange(new Range(dMin, dMin + dDif));
      plot.setWarningRange(new Range(dMax - dDif, dMax));
      plot.setNormalRange(new Range(dMin + dDif, dMax - dDif));
      plot.setMeterAngle(300);
      DialShape dialShape = DialShape.CIRCLE;
      if(iDialType == 0) {
         dialShape = DialShape.PIE;
      } else if(iDialType == 1) {
         dialShape = DialShape.CIRCLE;
      } else if(iDialType == 0) {
         dialShape = DialShape.CHORD;
      }

      plot.setDialShape(dialShape);
      JFreeChart chart = new JFreeChart(title, new Font("SansSerif", 1, 14), plot, false);
      chart.setBackgroundPaint(new GradientPaint(0.0F, 0.0F, Color.white, 0.0F, 1000.0F, Color.blue));
      return chart;
   }

   public void setBookstyle(String newM_bookstyle) {
      this.m_bookstyle = newM_bookstyle;
   }

   public void setCurrTypePK(String strCurrTypePK) {
      this.m_currTypePK = strCurrTypePK;
   }

   public void setDataset(StorageDataSet dataset, int iOutWidth) {
      this.m_dataset = dataset;
      DBReportTableModel tm = new DBReportTableModel();
      tm.setDataSet(this.m_dataset);
      tm.setPk_corp(this.m_pkCorp);
      tm.setCurrentCurrtypePK(this.m_currTypePK);
      tm.setfixColumnSize(this.m_fixColumnSize);
      tm.setBookstyle(this.m_bookstyle);
      this.getTable().setModel(tm);
      this.getTable().getSelectionModel().setSelectionInterval(0, 0);
      int iColCount = tm.getColumnCount();
      int colCount;
      int i;
      if(iColCount > 0 && iColCount < 10) {
         int[] mainRenderer = new int[iColCount];
         colCount = iOutWidth / iColCount;
         if(colCount < 100) {
            colCount = 100;
         }

         for(i = 0; i < iColCount; ++i) {
            mainRenderer[i] = colCount;
         }

         this.getTable().setColumnWidth(mainRenderer);
         this.getTable().sizeColumnsToFit(-1);
      }

      QueryBrowseCellRenderer var9 = new QueryBrowseCellRenderer();
      var9.setfixColumnSize(this.m_fixColumnSize);
      colCount = this.getTable().getColumnCount();

      for(i = 0; i < colCount; ++i) {
         TableColumn col = this.getTable().getColumnModel().getColumn(i);
         col.setCellRenderer(var9);
      }

   }

   public void setDsBeforeRotate(StorageDataSet dsBeforeRotate) {
      this.m_dsBeforeRotate = dsBeforeRotate;
   }

   public void setfixColumnSize(int size) {
      this.m_fixColumnSize = size;
   }

   public void setPKCorp(String strPKCorp) {
      this.m_pkCorp = strPKCorp;
   }

   public void setRemovingData() {
      DBReportTableModel tm = new DBReportTableModel();
      StorageDataSet dataset = new StorageDataSet();
      Column[] cols = new Column[1];
      Column newCol = new Column(NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000119"), NCLangRes.getInstance().getStrByID("20021386001", "UPP20021386001-000120"), 16);
      cols[0] = newCol;
      dataset.setColumns(cols);
      DataRow dr = new DataRow(dataset);
      dr.setString(0, "");
      dataset.open();
      dataset.addRow(dr);
      tm.setDataSet(dataset);
      this.getTable().setModel(tm);
      this.updateUI();
   }

   public void setSelRow(int iSelRow) {
      this.getTable().getSelectionModel().setSelectionInterval(iSelRow, iSelRow);
      this.getTable().scrollRectToVisible(this.getTable().getCellRect(iSelRow, 0, false));
   }

   public void valueChanged(ListSelectionEvent e) {
   }
}
